AngularJS-Learning
==================

NOTE: As of July 20, 2015, there is a [new repo for collecting links to Angular 2] (https://github.com/jmcunningham/AngularJS2-Learning). This list is barebones at the moment, so feel free to start adding links via PRs :)

A bunch of links to blog posts, articles, videos, etc for learning AngularJS. Feel free to submit a pull request if you have some links/resources to add. Also, I try to verify that the articles below have some real content (i.e. aren't 2 paragraph blog posts with little information) to ensure I'm not listing "fluff" pieces. If you have an idea for a better way to organize these links, please let me know. As I find similar posts in the "General Topics" section, I will break them out into their own categories.

I also blog about Angular and JavaScript topics at [my blog] (http://www.jmcunningham.net).

NOTE: LINKS PRECEDED WITH A ** DISCUSS NEW STUFF IN ANGULAR 1.3. Google's post announcing the release of 1.3.0 is [here] (http://angularjs.blogspot.com/2014/10/angularjs-130-superluminal-nudge.html). And the [migration guide] (https://docs.angularjs.org/guide/migration#migrating-from-1-2-to-1-3) from 1.2 to 1.3.

NOTE 2: Soon, I plan to remove all links that deal with Angular 1.0 or 1.1. All links will be 1.2 and above.

### Table of Contents
[Books](#books)
[Videos](#videos)
[Courses](#courses)
[Help](#help)
[General Topics](#general-topics)
[Introductions/Beginning AngularJS](#introductionsbeginning-angularjs-also-look-at-the-multipart-articles)
[Curation](#curation)
[Best Practices/Style Guides](#best-practicesstyle-guides)
[Lessons Learned](#lessons-learned)
[Boilerplates/Seed Projects](#boilerplatesseed-projects)
[Multipart Articles](#multipart-articles)
[Sample Apps](#sample-apps)
[Scopes & Compile](#scopes--compile)
[Dependency Injection](#dependency-injection)
[Directives](#directives)
[Services/Providers](#servicesproviders)
[Routing](#routing)
[Promises/Deferred](#promisesdeferred)
[Forms](#forms)
[Authentication](#authentication)
[Collections](#collections--ngrepeat-stuff)
[Code Organization](#code-organization)
[Testing](#testing)
[RESTful Stuff](#restful-stuff)
[Localization](#localization)
[UI Stuff](#ui-stuff)
[Integration with Other Languages/Frameworks](#integration-with-other-languagesframeworks)
[Hosted Backends](#integration-with-other-languagesframeworks)
[Mobile](#mobile)
[Popular Third-Party Modules](#popular-third-party-modules)
[Test Editor Bundles](#text-editor-bundleside-stuff)
[Development Tools](#development-tools)

## Books
| Title                                                                                                                                                   |                  Author                  |       Publisher      |    ng Version    | Last Update |
|---------------------------------------------------------------------------------------------------------------------------------------------------------|:----------------------------------------:|:--------------------:|:----------------:|:-----------:|
| [AngularJS: Up & Running](http://shop.oreilly.com/product/0636920033486.do)                                                                                           | Brad Green, Shyam Seshadri               | O'Reilly             | v1.2.x  |   9/2014  |
| [AngularJS In Action](http://www.manning.com/bford/)                                                                                                    | Brian Ford, Lukas Ruebbelke              | Manning Publications | v1.0.4 - v1.2.14 |     WIP     |
| [Mastering Web Application Development With AngularJS](https://www.packtpub.com/web-development/mastering-web-application-development-angularjs)        | Peter Bacon Darwin, Pawel Kozlowski      | Packt Publishing     | v1.0.2 - v1.0.7  |   8/1/2013  |
| [ng-book](https://www.ng-book.com)                                                                                                                      | Ari Lerner                               | Self-published       | v1.0.7 - v1.3.x  |  6/24/2014  |
| [Build Your Own AngularJS](http://teropa.info/build-your-own-angular)                                                                                   | Tero Parviainen                          | Self-published       | v1.x             |     WIP     |
| [Dependency Injection with AngularJS](https://www.packtpub.com/web-development/dependency-injection-angularjs)                                          | Alex Knol                                | Packt Publishing     | ?                |  12/1/2013  |
| [Learning Web Development with Bootstrap and Angular: RAW](https://www.packtpub.com/web-development/learning-web-development-bootstrap-and-angular-raw) | Stephen Radford                          | Packt Publishing     | v1.2.x - v1.3    |     WIP     |
| [AngularJS Essentials](https://www.packtpub.com/web-development/angularjs-essentials)                                                                   | Rodrigo Branas                           | Packt Publishing     | ?                |     WIP     |
| [AngularJS Web application development Blueprints : RAW](https://www.packtpub.com/web-development/angularjs-web-application-development-blueprints-raw) | Vinci Rufus                              | Packt Publishing     | ?                |     WIP     |
| [AngularJS UI Development](https://www.packtpub.com/web-development/angularjs-ui-development)                                                           | Matthias Nehlsen, Amit Gharat            | Packt Publishing     | v1.2.22 - v1.2.x |     WIP     |
| [D3 on AngularJS](https://leanpub.com/d3angularjs)                                                                                                      | Ari Lerner, Victor Powell                | Leanpub              | v1.0.7 - v1.2.11 |   6/6/2014  |
| [Mastering AngularJS Directives](https://www.packtpub.com/application-development/mastering-angularjs-directives)                                       | Josh Kurz                                | Packt Publishing     | v1.2.2 - v1.2.16 |   6/1/2014  |
| [AngularJS: Novice to Ninja](https://learnable.com/books/angularjs-novice-to-ninja/) | Sandeep Panda | SitePoint | v1.3.0-beta.2 | 25/9/2014 |
| [Discover AngularJS](https://leanpub.com/discoverangularjs) | Adam Burak | Leanpub | ? | 2014/11/10 |
| [Pro AngularJS](http://www.apress.com/9781430264484) | Adam Freeman | Apress | v1.2.x | 02/04/2014 |
| [Learning AngularJS](http://www.pearsoned.co.uk/bookshop/detail.asp?item=100000000595964) | Brad Dayley | Addison Wesley | v1.3.x | 12/1/2014
| [AngularJS By Example](https://www.packtpub.com/web-development/angularjs-example) | Chandermani | Packt Publishing | v1.3.x | 3/12/2015
| [Angular Basics](http://www.angularjsbook.com/angular-basics/chapters/) | Chris Smith | Scripty Books | v1.3.x | 3/15/2015 |
| [Recipes with Angular.js](https://leanpub.com/recipes-with-angular-js/read)| Frederik Dietz | Leanpub | ? | ? |
| [AngularJS Cookbook](https://leanpub.com/angularjs-cookbook)| Sascha Brink | Leanpub | v1.2.x | ? |
| [AngularJS with Ruby on Rails](http://angular-rails.com/)| David Bryant Copeland | ? | ? | ? |
| [Practical AngularJS](https://leanpub.com/Practical_AngularJS)| Dinis Cruz | Leanpub | ? | ? |
| [Web Component Architecture & Development with AngularJS](https://leanpub.com/web-component-development-with-angularjs)| David Shapiro | Leanpub | v1.2.16 | ? |
| [Deep Dive into Angular.js Directives](https://leanpub.com/angularjsdirectives) | Jesús Rodríguez | Leanpub | v.1.3.x | 

## Videos
* [Egghead.io](http://www.egghead.io/) — [source code](https://github.com/msfrisbie/egghead-angularjs)
* [Video Tutorial: AngularJS Fundamentals in 60-ish Minutes](http://weblogs.asp.net/dwahlin/archive/2013/04/12/video-tutorial-angularjs-fundamentals-in-60-ish-minutes.aspx) — 1:10:50
* [AngularJS YouTube Page](http://www.youtube.com/user/angularjs) — several videos, mostly presentations of 1h or more
* [Intro to Angular JS](http://www.youtube.com/watch?v=8ILQOFAgaXE) — 50:05
* [End to End with Angular JS](http://www.youtube.com/watch?v=hqAyiqUs93c) — 52:59
* [Security with Angular JS](http://www.youtube.com/watch?v=18ifoT-Id54) — 29:45
* [Frontend Workflows with Grunt and Angular JS](http://www.youtube.com/watch?v=fSAgFxjFSqY) — 1:02:37
* [AngularJS Tutorial](http://www.youtube.com/watch?v=WuiHuZq_cg4) — 12:19
* [Easier JavaScript Apps with AngularJS (Tuts+)](https://tutsplus.com/course/easier-js-apps-with-angular/) — 22 videos of about 5 minutes each, in 8 sections (paid)
* [AngularJS Fundamentals (Pluralsight)] (http://pluralsight.com/training/Courses/TableOfContents/angularjs-fundamentals) - 6 hours 15 minutes total (paid)
* [AngularJS 1.2 & Beyond] (http://www.youtube.com/watch?v=W13qDdJDHp8&feature=youtu.be)
* [Realtime Web Apps With AngularJS & Firebase] (http://www.youtube.com/watch?v=C7ZI7z7qnHU)
* [Getting MEAN With MongoDB and AngularJS](https://www.youtube.com/watch?v=XwSFg8nqBFA)
* [A comparison of the two-way binding in AngularJS, EmberJS and KnockoutJS](http://www.youtube.com/watch?v=mVjpwia1YN4)
* [Angular Best Practices](http://pluralsight.com/training/courses/TableOfContents?courseName=angular-best-practices&highlight=) - 64 videos(paid)
* [Neosavvy's Angular & Jasmine Screencast Series](http://www.youtube.com/channel/UCdaEMffiYgTf_E7uTMxM4og/videos) - 16 videos of about 2-3 minutes each
* [AngularJS Videos Collection in Youtube](http://www.youtube.com/channel/UCNhQ8pYS9U1EbwCx42NKaYQ) — Collection of Videos from Various websites.
* [ng-conf YouTube Page](http://www.youtube.com/user/ngconfvideos) — YouTube channel with all the presentations given at the Angular Conference in January 2014.
* [Introduction to Angular.js in 50 Examples (part 1)] (https://www.youtube.com/watch?v=TRrL5j3MIvo&feature=youtu.be)
* [Real-Time Web Apps With AngularJS and Firebase](https://courses.tutsplus.com/courses/real-time-web-apps-with-angularjs-and-firebase) - Paid
* [Learn to build an application using Angular.js](http://campus.codeschool.com/courses/shaping-up-with-angular-js/intro)
* [Building a Web App From Scratch With AngularJS](http://code.tutsplus.com/courses/building-a-web-app-from-scratch-with-angularjs) - Paid
* [Reddit Clone ](https://www.youtube.com/playlist?list=PLV_Z6DwQEeBvcKHnYbBjHHKe36cU5agAA)
* [AngularJS Directives Fundamentals](http://www.pluralsight.com/courses/angularjs-directive-fundamentals) - Paid
* [Ninja: Building MVP with AngularJS + FireBase by cloning TaskRabbit](http://code4startup.com/projects/ninja-learn-angularjs-firebase-by-cloning-udemy)
* [AngularJS Services In-depth](http://www.pluralsight.com/courses/angularjs-services-in-depth) - Paid
* [AngularJS Office Hours with AngularUI Founder: Best Practices, UI-Router, and ORM](https://www.codementor.io/angularjs/tutorial/angularjs-best-practices-ui-router-orm)
* [Learn AngularJs by Building 10 Projects](http://www.eduonix.com/courses/Web-Development/Learn-Angular.Js-by-Building-10-Projects) - Paid
* [AngularJS for Test-Driven Development](http://code.tutsplus.com/courses/angularjs-for-test-driven-development)
* [Treehouse Tutorial](http://teamtreehouse.com/library/angularjs) - Paid
* [Creating a Quiz with AngularJS](http://www.lynda.com/AngularJS-tutorials/Creating-Quiz-AngularJS/373557-2.html) - Paid
* [Angular Routing In-depth](http://www.pluralsight.com/courses/angular-routing-in-depth) - Paid

## Courses

* [AngularJS for the Real World - Learn by creating a WebApp](https://www.udemy.com/angularjs-for-the-real-world-learn-to-create-a-webapp/?couponCode=gitdev19A) - 6 hrs video  + source code (Paid 85% discount)
* [The Angular Course - Launch a full product with AngularJS](https://www.angularcourse.com) - Over 7 hrs of HD video (Paid)
* [AngularJS Tutorial - Learn Angular by building a Gmail clone](http://www.thinkful.com/learn/angularjs-tutorial-build-a-gmail-clone) – Mini AngularJS course with video
* [AngularJS JumpStart with Dan Wahlin] (https://www.udemy.com/angularjs-jumpstart/?sl=E0EYdlw9RBMALEwzBwZX)
* [Tuts+: Hands-on Angular] (https://tutsplus.com/course/hands-on-angular/)
* [Code School Shaping Up with Angular.js](https://www.codeschool.com/courses/shaping-up-with-angular-js)
* [Lynda Up and Running with AngularJS](http://www.lynda.com/AngularJS-tutorials/Up-Running-AngularJS/154414-2.html)
* [Codecademy AngularJs](http://www.codecademy.com/courses/javascript-advanced-en-2hJ3J/0/1)
* [Learn and Understand AngularJS](https://www.udemy.com/learn-angularjs/?couponCode=GH19)
* [Pluralsight: AngularJS Patterns: Clean Code] (http://www.pluralsight.com/courses/angularjs-patterns-clean-code)
* [Pluralsight: AngularJS Line of Business Applications] (http://www.pluralsight.com/courses/angularjs-line-of-business-applications)
* [Building Mobile Apps With the Ionic Framework and AngularJS] (http://www.pluralsight.com/courses/building-mobile-apps-ionic-framework-angularjs)
* [Thinkster: AngularJS Tutorial: Learn to Build Modern Web Apps with MEAN](https://thinkster.io/mean-stack-tutorial/)
* [Thinkster: Building Web Applications with Django and AngularJS](https://thinkster.io/django-angularjs-tutorial/)
* [Thinkster: Building Web Applications with Rails and AngularJS](https://thinkster.io/angular-rails/)
* [Thinkster: Learn to Build a Real-Time Reddit Clone with Firebase and AngularJS](https://thinkster.io/learn-to-build-realtime-webapps/)
* [Thinkster: Mastering the Ionic Framework](https://thinkster.io/ionic-framework-tutorial/)
* [**AngularJS Tutorial - Learn AngularJS in 30 minutes](http://www.revillweb.com/tutorials/angularjs-in-30-minutes-angularjs-tutorial/)
* [AngularJS Tutorial - W3Schools](http://www.w3schools.com/angular/default.asp)
* [Learn Angular](http://www.learn-angular.org/)
* [Tagtree Angular Course](http://tagtree.io/courses/angular)

## Curation
* [AngularJS Content Curation for 7 Days + Demo](http://angularjs.runastartup.com)
* [Angular-js.in | Curated list of angular directives](http://angular-js.in/)

## Help
* [StackOverflow] (http://stackoverflow.com/questions/tagged/angularjs)
* [AngularJS Mailing List (Google Groups)] (http://groups.google.com/group/angular)
* [Chatroom (Browser-based IRC)] (http://webchat.freenode.net/?channels=angularjs&uio=d4)
* [AngularJS Google+ Community] (https://plus.google.com/u/0/communities/115368820700870330756)
* [reddit] (http://www.reddit.com/r/angularjs)

## General Topics
* [AngularJS Cheat Sheet] (http://www.cheatography.com/proloser/cheat-sheets/angularjs/)
* [What stumped me about AngularJS] (http://www.peterbe.com/plog/what-stumped-me-about-angularjs)
* [Lazy Loading In AngularJS] (http://ify.io/lazy-loading-in-angularjs/)
* [HashKeyCopier - An AngularJS Utility Class For Merging Cached And Live Data] (http://www.bennadel.com/blog/2472-HashKeyCopier-An-AngularJS-Utility-Class-For-Merging-Cached-And-Live-Data.htm)
* [Exploring Directives, $scope, DOM Rendering, And Timing In AngularJS] (http://www.bennadel.com/blog/2444-Exploring-Directives-scope-DOM-Rendering-And-Timing-In-AngularJS.htm)
* [Applying A Cached Response To An AngularJS Resource] (http://www.bennadel.com/blog/2432-Applying-A-Cached-Response-To-An-AngularJS-Resource.htm)
* [Angularytics: The solution to tracking page views and events in a SPA with AngularJS] (http://www.blogeek.com.ar/2013/06/03/angularytics-the-solution-to-tracking-page-views-and-events-in-a-spa-with-angularjs/)
* [Sharing Data, State and Models on AngularJS: Alternatives, comparison and my solution] (http://www.blogeek.com.ar/2013/05/01/sharing-data-state-on-angularjs-alternatives-comparison-and-my-solution/)
* [Angular.js and IE8 caching] (http://www.jefclaes.be/2013/06/angularjs-and-ie8-caching.html)
* [HTML5 local storage with Angular JS] (http://amitavroy.com/justread/content/articles/html5-local-storage-angular-js)
* [Modeling Data and State in Your AngularJS Application] (http://joelhooks.com/blog/2013/04/24/modeling-data-and-state-in-your-angularjs-application/)
* [Code Reuse in AngularJS] (http://www.phase2technology.com/blog/code-reuse-in-angularjs/)
/dynamically-loading-controllers-and-views-with-angularjs-and-requirejs.aspx)
* [Sorting by Multiple Fields with Different Sort Orders Using the AngularJS orderby Filter] (http://htmlcssjavascript.com/javascript/sorting-by-multiple-fields-with-different-sort-orders-using-the-angularjs-orderby-filter/)
* [$http Response Interceptors] (http://blog.brunoscopelliti.com/http-response-interceptors)
* [AngularJS: Advanced Design Patterns & Best Practices] (http://trochette.github.io/Angular-Design-Patterns-Best-Practices/#/intro)
* [Automatic JSON date parsing with AngularJS] (http://aboutcode.net/2013/07/27/json-date-parsing-angularjs.html)
* [AngularJS Abstractions: Modules] (http://odetocode.com/blogs/scott/archive/2013/05/01/angularjs-abstractions-modules.aspx)
* [Mixing Static Content With ngSwitch And ngSwitchWhen In AngularJS] (http://www.bennadel.com/blog/2507-Mixing-Static-Content-With-ngSwitch-And-ngSwitchWhen-In-AngularJS.htm)
* [Building large apps with AngularJS] (http://pseudobry.com/building-large-apps-with-angularjs.html)
* [Error Message Minification with MinErr] (http://kensheedlo.com/2013/08/15/error-message-minification-with-minerr.html)
* [How to make your AngularJS app work in IE 8] (http://blog-it.hypoport.de/2013/08/24/how-to-make-your-angularjs-app-work-in-ie-8/)
* [AngularJS Performance Tuning for Long Lists] (http://tech.small-improvements.com/2013/09/10/angularjs-performance-with-large-lists/)
* [Responsive Website Using AngularJS] (http://www.innerhtml.com/responsive-website-using-angularjs.html)
* [Minimizing initialization time in AngularJS] (https://medium.com/p/f8ae57e2cec3)
* [Kickstart Your AngularJS Development with Yeoman, Grunt and Bower] (http://www.sitepoint.com/kickstart-your-angularjs-development-with-yeoman-grunt-and-bower/)
* [Lazy prefetching of AngularJS partials] (http://blog.mgechev.com/2013/10/01/angularjs-partials-lazy-prefetching-strategy-weighted-directed-graph/)
* [Enhancing AngularJS $log using Decorators] (http://solutionoptimist.com/2013/10/07/enhance-log-using-angularjs-decorators/)
* [Logging Client-Side Errors With AngularJS And Stacktrace.js] (http://www.bennadel.com/blog/2542-Logging-Client-Side-Errors-With-AngularJS-And-Stacktrace-js.htm)
* [Form Autocomplete and Remember Password with AngularJS] (http://timothy.userapp.io/post/63412334209/form-autocomplete-and-remember-password-with-angularjs)
* [Optimizing AngularJS: 1200ms to 35ms](http://blog.scalyr.com/2013/10/31/angularjs-1200ms-to-35ms/)
* [Creating A RequireJS Service For AngularJS Applications] (http://www.bennadel.com/blog/2551-Creating-A-RequireJS-Service-For-AngularJS-Applications.htm)
* [Loading AngularJS Components After Your Application Has Been Bootstrapped] (http://www.bennadel.com/blog/2553-Loading-AngularJS-Components-After-Your-Application-Has-Been-Bootstrapped.htm)
* [Load a module on demand with AngularJS] (http://blog.getelementsbyidea.com/load-a-module-on-demand-with-angularjs/)
* [Environment Specific Configuration in AngularJS Using Grunt] (http://newtriks.com/2013/11/29/environment-specific-configuration-in-angularjs-using-grunt/)
* [What’s the Role of the Server in Single Page Applications (SPAs)?](http://weblogs.asp.net/dwahlin/archive/2014/02/18/what-s-the-role-of-the-server-in-single-page-applications-spas.aspx)
* [Making Angular.js realtime with Websockets](http://blog.pusher.com/making-angular-js-realtime-with-pusher/)
* [Rich Object Models and Angular.js] (http://blog.shinetech.com/2014/02/04/rich-object-models-and-angular-js/)
* [Rich Object Models and Angular: Identity Maps] (http://blog.shinetech.com/2014/02/28/rich-object-models-and-angular-identity-maps/)
* [Interceptors in AngularJS and Useful Examples] (http://www.webdeveasy.com/interceptors-in-angularjs-and-useful-examples/)
* ['Resolve' in AngularJS Routes, Explained as Story](http://www.undefinednull.com/2014/02/17/resolve-in-angularjs-routes-explained-as-story/)
* [Get Your Hands Dirty Refactoring in AngularJS] (http://blog.safaribooksonline.com/2014/04/08/refactoring-angularjs-get-hands-filthy/)
* [Angular model objects with JavaScript classes] (https://medium.com/opinionated-angularjs/2e6a067c73bc)
* [The state of angularjs controllers] (http://jonathancreamer.com/the-state-of-angularjs-controllers/)
* [How to use ngMessages in AngularJS] (http://www.yearofmoo.com/2014/05/how-to-use-ngmessages-in-angularjs.html)
* [Digging into Angular’s “Controller as” syntax] (http://toddmotto.com/digging-into-angulars-controller-as-syntax/)
* [Everything about custom filters in AngularJS](http://toddmotto.com/everything-about-custom-filters-in-angular-js/)
* [Understanding Angular’s $scope and $rootScope event system $emit, $broadcast and $on ](http://toddmotto.com/all-about-angulars-emit-broadcast-on-publish-subscribing/)
* [Frictionless data preloading in AngularJS](http://www.garbl.es/angularjs/preload/2014/06/07/frictionless-data-preloading-in-angularjs/)
* [Minimal Angular module/syntax approach using an IIFE](http://toddmotto.com/minimal-angular-module-syntax-approach-using-an-iife/)
* [AngularJS & SEO - finally a piece of cake](https://weluse.de/blog/angularjs-seo-finally-a-piece-of-cake.html)
* [Best Practices for Building Angular.js Apps](https://medium.com/@dickeyxxx/best-practices-for-building-angular-js-apps-266c1a4a6917)
* [Building applications for Firefox OS using AngularJS](https://hacks.mozilla.org/2014/07/building-applications-for-firefox-os-using-angularjs/)
* [Debugging AngularJS Apps from the Console](http://ionicframework.com/blog/angularjs-console/)
* [50 Angular.js Examples](http://curran.github.io/screencasts/introToAngular/exampleViewer/#/)
* [AngularJS DOM manipulation with jqLite](http://baljeetsingh.in/angularjs-dom-manipulation-jqlite-324/)
* [A Developer’s Guide to Perform SEO on AngularJS Web Apps](http://www.algoworks.com/blog/a-developers-guide-to-perform-seo-on-angularjs-web-apps/)
* [The Top 10 Mistakes AngularJS Developers Make](http://www.airpair.com/angularjs/posts/top-10-mistakes-angularjs-developers-make)
* [How I've Improved My Angular Apps by Banning ng-controller ](http://teropa.info/blog/2014/10/24/how-ive-improved-my-angular-apps-by-banning-ng-controller.html)
* **[Exploring Angular 1.3 - Angular-Hint](http://blog.thoughtram.io/angularjs/2014/11/06/exploring-angular-1.3-angular-hint.html)
* [**Exploring Angular 1.3 - Stateful Filters] (http://blog.thoughtram.io/angularjs/2014/11/19/exploring-angular-1.3-stateful-filters.html)
* [**ngEurope: what's new in Angular 1.3?] (http://petermorlion.blogspot.com/2014/10/ngeurope-whats-new-in-angular-13.html)
* [AngularJS: The Bad Parts](http://larseidnes.com/2014/11/05/angularjs-the-bad-parts/)
* [The Top 5 Mistakes AngularJS Developers Make Part 3: Overusing $broadcast and $emit](http://csharperimage.jeremylikness.com/2014/12/the-top-5-mistakes-angularjs-developers.html)
* [Making Skinny AngularJS Controllers](https://scotch.io/tutorials/making-skinny-angularjs-controllers)
* [Using RequireJS in AngularJS Applications](http://www.sitepoint.com/using-requirejs-angularjs-applications/)
* [You don't always need DI in AngularJS directives](http://michalostruszka.pl/blog/2015/01/18/angular-directives-di/)
* [AngularJS’ Internals In Depth](http://www.smashingmagazine.com/2015/01/22/angularjs-internals-in-depth/)
* [Custom Root URIs For User Profiles with AngularJS](https://medium.com/@internrocket/custom-root-uris-for-user-profiles-with-angularjs-eff3b3458510)
* [Resources to Master AngularJS](https://netguru.co/blog/resources-to-master-angularjs)
* [A Preview of Angular 2 and TypeScript in Visual Studio](http://blogs.msdn.com/b/visualstudio/archive/2015/03/12/a-preview-of-angular-2-and-typescript-in-visual-studio.aspx)
* [11 Tips to Improve AngularJS Performance](http://www.alexkras.com/11-tips-to-improve-angularjs-performance/)
* [Creating your first Angular 2 app: From authentication to calling an API and everything in between](https://auth0.com/blog/2015/05/14/creating-your-first-real-world-angular-2-app-from-authentication-to-calling-an-api-and-everything-in-between)
* [How to do loading spinners, the Angular way.](http://codetunnel.io/how-to-do-loading-spinners-the-angular-way/)
* [The offline experience (or, saying goodbye to imperative data fetching)](https://medium.com/@plestik/the-offline-experience-or-saying-goodbye-to-imperative-data-fetching-9b2fa487eea7)
* [Exploring the Angular 1.5 .component() method](http://toddmotto.com/exploring-the-angular-1-5-component-method/)

## Introductions/Beginning AngularJS (also look at the multipart articles)

* [Getting Started With AngularJS] (http://www.adobe.com/devnet/html5/articles/getting-started-with-angularjs.html)
* [AngularJS Tutorial: A Comprehensive 10,000 Word Guide](https://www.airpair.com/angularjs/posts/angularjs-tutorial)
* [Everything you need to understand to start with AngularJS] (http://stephanebegaudeau.tumblr.com/post/48776908163/everything-you-need-to-understand-to-start-with)
* [What To Know To Be An Expert in AngularJS] (http://codigovivo.com/2013/06/09/what-to-know-to-be-an-expert-in-angularjs/)
* [AngularJS for jQuery Developers] (http://blog.artlogic.com/2013/03/06/angularjs-for-jquery-developers/)
* [An Introduction to AngularJS] (http://www.webdesignerdepot.com/2013/04/an-introduction-to-angularjs/)
* [Building a Web App From Scratch in AngularJS] (http://net.tutsplus.com/tutorials/javascript-ajax/building-a-web-app-from-scratch-in-angularjs/)
* [AngularJS: An Overview] (http://glennstovall.com/blog/2013/06/27/angularjs-an-overview/)
* [AngularJS Tutorial — Build an App Using Directives and Data Binding](http://www.sitepoint.com/angularjs-tutorial-build-an-app-using-directives-and-data-binding/)
* [AngularJS In 30 Minutes] (http://www.revillwebdesign.com/angularjs-tutorial/)
* [Kickstart Your AngularJS Development with Yeoman, Grunt and Bower] (http://www.sitepoint.com/kickstart-your-angularjs-development-with-yeoman-grunt-and-bower/)
* [Filtering with AngularJS] (http://www.kidsil.net/2013/09/filtering-with-angularjs/)
* [Ultimate guide to learning AngularJS in one day] (http://toddmotto.com/ultimate-guide-to-learning-angular-js-in-one-day/)
* [7 Ways to be Successful with AngularJS] (http://learnangularjs.net/2013/10/24/7-ways-to-be-successful-with-angularjs/)
* [Creating a Single Page Todo App with Node and Angular](http://scotch.io/tutorials/javascript/creating-a-single-page-todo-app-with-node-and-angular)
* [Learn AngularJS With These 5 Practical Examples] (http://tutorialzine.com/2013/08/learn-angularjs-5-examples)
* [Considering Speed and Slowness in AngularJS] (https://www.exratione.com/2013/12/considering-speed-and-slowness-in-angularjs/)
* [Environment Specific Configuration in AngularJS Using Grunt] (http://newtriks.com/2013/11/29/environment-specific-configuration-in-angularjs-using-grunt/)
* [Enhancing AngularJS Logging using Decorators](http://solutionoptimist.com/2013/10/07/enhance-angularjs-logging-using-decorators/)
* [Picking Up Angular, build a twitter-like application](https://github.com/deontologician/pipr/blob/master/tut.org)
* [Exception Handling in an AngularJS Web Application] (http://blog.loadimpact.com/2014/06/03/exception-handling-in-an-angularjs-web-application-tutorial/)
* [AngularJS 101: From Zero to Angular in Seconds] (http://www.pubnub.com/blog/angularjs-101-from-zero-to-angular-in-seconds/)
* [AngularJS Tutorial: A Comprehensive 10,000 Word Guide](http://www.airpair.com/angularjs)
* [Thinkster: A Better Way to Learn AngularJS](https://thinkster.io/a-better-way-to-learn-angularjs/)
* [Breaking Down AngularJS to Smaller Components](https://medium.com/@srph/breaking-down-angularjs-to-smaller-components-f2ab70a104d0)
* [Managing Client-Only State in AngularJS](http://www.sitepoint.com/managing-client-state-angularjs/)
* [***AngularJS one-time binding syntax](http://toddmotto.com/angular-one-time-binding-syntax/)

### Tutorial Series
* [Part 1 -- Building a Calendar with LESS CSS, Font Awesome, and Moment](https://www.codementor.io/angularjs/tutorial/angularjs-calendar-directives-less-cess-moment-font-awesome)
* [Part 2 -- Flipping Tiles with CSS3 Animations and AngularJS](https://www.codementor.io/angularjs/tutorial/animated-flip-tiles-css3-angularjs)
* [Part 3 -- How to Make a Sliding Menu with Directives](https://www.codementor.io/angularjs/tutorial/making-a-sliding-menu-with-directives-less-css)
* [Part 4 -- Creating a Focus Text Box Control With Fancy Feedback](https://www.codementor.io/angularjs/tutorial/focus-text-box-control-feedback-input-less-css)
* [Part 5 -- Creating a Dropdown Control For Your Site](https://www.codementor.io/angularjs/tutorial/create-dropdown-control)

## Best Practices/Style Guides
* [***My Personal Angular JS Best Practices Guide] (https://github.com/jmcunningham/angularjs-styleguide)
* [Opinionated AngularJS styleguide for teams] (http://toddmotto.com/opinionated-angular-js-styleguide-for-teams/)
* [AngularJS Style Guide](https://github.com/johnpapa/angularjs-styleguide) by John Papa: A starting point for AngularJS development teams to provide consistency through good practices.
* [AngularJS Best Practices: Directory Structure](http://scotch.io/tutorials/javascript/angularjs-best-practices-directory-structure)
* [AngularJS style guide used at GoCardless] (https://github.com/gocardless/angularjs-style-guide)
* [Learn AngularJS Online - A Guide](https://www.codementor.io/learn-angularjs)

## Lessons Learned
* [Lessons Learned: A Year with a Large AngularJS Project] (http://joelhooks.com/blog/2013/05/22/lessons-learned-kicking-off-an-angularjs-project/)
* [Some AngularJS Pitfalls] (http://branchandbound.net/blog/web/2013/08/some-angularjs-pitfalls/)
* [Things I Wish I Were Told About Angular.js] (http://ruoyusun.com/2013/05/25/things-i-wish-i-were-told-about-angular-js.html)
* [I Wish I Knew Then What I Know Now — Life With AngularJS] (http://www.objectpartners.com/2013/08/09/i-wish-i-knew-then-what-i-know-now-life-with-angularjs/)
* [How to build a large Angular.js application] (https://gocardless.com/blog/building-a-large-angular-application/)
* [AngularJS tips and tricks for neophytes and the all-around curious developer.] (http://www.bytesforthought.com/angularjs-tips/)
* [4 Smooth AngularJS Application Tips] (http://nathanleclaire.com/blog/2014/01/04/5-smooth-angularjs-application-tips/)
* [Get Your Hands Dirty Refactoring in AngularJS] (http://blog.safaribooksonline.com/2014/04/08/refactoring-angularjs-get-hands-filthy/)
* [5 AngularJS Antipatterns & Pitfalls] (http://nathanleclaire.com/blog/2014/04/19/5-angularjs-antipatterns-and-pitfalls/)
* [Speeding up AngularJS apps with simple optimizations](http://www.binpress.com/tutorial/speeding-up-angular-js-with-simple-optimizations/135)
* [AngularJS Performance in Large Applications](https://www.airpair.com/angularjs/posts/angularjs-performance-large-applications)

## Boilerplates/Seed Projects
* [Angular Dashboard Seed](https://github.com/flatlogic/angular-dashboard-seed)
* [***My Personal Angular JS Seed Project] (https://github.com/jmcunningham/angularBPSeed)
* [Modern Web Seed Project](https://github.com/cjus/modern-web-seed)
* [KOAN Stack (Koa, Angular, Node, Mongo, WebSockets)](https://github.com/soygul/koan)
* [loopback-angular-admin (Loopback REST API with a AngularJS frontend)](https://github.com/beeman/loopback-angular-admin)

## Multipart Articles
* Getting Started with elasticsearch and AngularJS: [Part1 - Searching] (http://www.fullscale.co/blog/2013/02/28/getting_started_with_elasticsearch_and_AngularJS_searching.html), [Part 2: Faceting] (http://www.fullscale.co/blog/2013/03/07/getting_started_with_elasticsearch_and-AngularJS_faceting.html), [Part 3: Visualization] (http://www.fullscale.co/blog/2013/03/20/getting_started_with_elasticsearch_and_AngularJS_d3.html)
* Maintainable Rich Web Applications with AngularJS: [Part 1] (http://blog.akquinet.de/2013/01/22/maintainable-rich-web-applications-with-angularjs/), [Part 2] (http://blog.akquinet.de/2013/03/21/maintainable-rich-web-applications-with-angularjs-part-2/)
* Google, Twitter & AngularJS: [1: Google, Twitter, and AngularJS] (http://dailyjs.com/2013/04/11/angularjs-1/), [2: Let's Make a Feed Reader] (http://dailyjs.com/2013/04/18/angularjs-2/), [3: Rendering Feeds] (http://dailyjs.com/2013/04/25/angularjs-3/), [4: Managing Feeds] (http://dailyjs.com/2013/05/09/angularjs-4/), [5: Tests] (http://dailyjs.com/2013/05/16/angularjs-5/), [6: Adding Dependencies] (http://dailyjs.com/2013/05/30/angularjs-6/), [7: Form Validation] (http://dailyjs.com/2013/06/06/angularjs-7/), [8: Iterators & Filters] (http://dailyjs.com/2013/06/13/angularjs-8/), [9: Installation](http://dailyjs.com/2013/07/18/angularjs-9/)
* Implementing SignalR Stock Ticker using Angular JS: [Part 1](http://sravi-kiran.blogspot.in/2013/05/ImplementingSignalRStockTickerUsingAngularJSPart1.html), [Part 2](http://sravi-kiran.blogspot.in/2013/05/ImplementingSignalRStockTickerUsingAngularJSPart2.html)
* AngularJS Best Practices: I’ve Been Doing It Wrong!: [Part 1] (http://blog.artlogic.com/2013/05/02/ive-been-doing-it-wrong-part-1-of-3/), [Part 2](http://blog.artlogic.com/2013/05/06/angularjs-best-practices-ive-been-doing-it-wrong-part-2-of-3/), [Part 3](http://blog.artlogic.com/2013/05/08/angularjs-best-practices-ive-been-doing-it-wrong-part-3-of-3/)
* Introduction to AngularJS [Part 1](http://www.raweng.com/blog/2013/01/30/introduction-to-angularjs-part-1/), [Part 2](http://www.raweng.com/blog/2013/05/16/introduction-to-angularjs-part-2/)
* AngularJS In Depth: [Part 1](http://suhairhassan.com/2013/06/07/angularjs-in-depth-part-1.html), [Part 2: Filters](http://suhairhassan.com/2013/07/25/angularjs-in-depth-part-2.html)
* [The 7 steps to becoming and AngularJS expert](http://www.ng-newsletter.com/posts/beginner2expert-how_to_start.html), [Part 2: Scopes](http://www.ng-newsletter.com/posts/beginner2expert-scopes.html), [Part 3: Data-binding](http://www.ng-newsletter.com/posts/beginner2expert-data-binding.html), [Part 4 and 5: Expressions and directives](http://www.ng-newsletter.com/posts/beginner2expert-directives.html), [Part 6: Services](http://www.ng-newsletter.com/posts/beginner2expert-services.html)
* AngularJS Overview: [1:Getting started with AngularJS](http://msmvps.com/blogs/theproblemsolver/archive/2013/04/05/getting-started-with-angularjs.aspx), [2:Creating an AngularJS Controller](http://msmvps.com/blogs/theproblemsolver/archive/2013/04/10/creating-an-angularjs-controller.aspx), [3:The AngularJS $scope is not the MVC Model](http://msmvps.com/blogs/theproblemsolver/archive/2013/04/15/the-angularjs-scope-is-not-the-mvc-model.aspx), [4:Using repeating elements in AngularJS](http://msmvps.com/blogs/theproblemsolver/archive/2013/05/10/using-repeating-elements-in-angularjs.aspx), [5:Filtering the data in an AngularJS ngRepeat element](http://msmvps.com/blogs/theproblemsolver/archive/2013/05/13/filtering-the-data-in-an-angularjs-ngrepeat-element.aspx), [6:Using the #AngularJS FormController to control form submission](http://msmvps.com/blogs/theproblemsolver/archive/2013/08/19/using-the-angularjs-formcontroller-to-control-form-submission.aspx), [7:Creating an #AngularJS Directive](http://msmvps.com/blogs/theproblemsolver/archive/2013/08/29/creating-an-angularjs-directive.aspx), [8:Using the DOM in an AngularJS application](http://msmvps.com/blogs/theproblemsolver/archive/2013/09/05/using-the-dom-in-an-angularjs-application.aspx), [9:To SPA or Not to SPA](http://msmvps.com/blogs/theproblemsolver/archive/2013/10/23/to-spa-or-not-to-spa.aspx)
* Building a Google Calendar Booking App with MongoDB, ExpressJS, AngularJS, and Node.js [Part 1](http://www.jonathanbroquist.com/blog/2013/10/building-a-google-calendar-booking-app-with-mongodb-expressjs-angularjs-and-node-js-part-1/), [Part 2](http://blog.jonathanbroquist.com/building-a-google-calendar-booking-app-with-mongodb-expressjs-angularjs-and-node-js-part-2/)
* Creating Extensible Widgets: [Part 1: jQuery to AngularJS in 30 seconds] (http://blog.thousandeyes.com/creating-extensible-widgets-part-1-jquery-to-angularjs/), [Part 2: AngularJS Directive Controllers] (http://blog.thousandeyes.com/creating-extensible-widgets-part-2-angularjs-directive-controllers/)
* Build a Sweet Photo Slider with AngularJS Animate: [Part 1](http://onehungrymind.com/build-sweet-photo-slider-angularjs-animate/), [Part 2:](http://onehungrymind.com/build-sweet-angularjs-photo-slider-pt-2-ngtouch/)
* A Practical Guide to AngularJS Directives: [Part 1](http://www.sitepoint.com/practical-guide-angularjs-directives/), [Part 2](http://www.sitepoint.com/practical-guide-angularjs-directives-part-two/)
* AngularJS Tutorial by Jakob Jenkov: [Introduction](http://tutorials.jenkov.com/angularjs/index.html), [Views & Directives](http://tutorials.jenkov.com/angularjs/views-and-directives.html), [Events](http://tutorials.jenkov.com/angularjs/events.html), [AJAX](http://tutorials.jenkov.com/angularjs/ajax.html), [Forms] (http://tutorials.jenkov.com/angularjs/forms.html), [Custom Directives](http://tutorials.jenkov.com/angularjs/custom-directives.html), [Critiques](http://tutorials.jenkov.com/angularjs/critique.html)
* Los Techies AngularJS Series: [Table of Contents: Parts 1-12](http://lostechies.com/gabrielschenker/2014/02/26/angular-js-blog-series-table-of-content/),
[Part 1](http://lostechies.com/gabrielschenker/2013/12/05/angularjspart-1/), [Part 2: The Controller](http://lostechies.com/gabrielschenker/2013/12/09/angularjspart-2-the-controller/), [Part 3: Inheritance](http://lostechies.com/gabrielschenker/2013/12/10/angularjspart-3-inheritance/), [Part 4: Accessing Server Side Resources](http://lostechies.com/gabrielschenker/2013/12/12/angularjspart-4-accessing-server-side-resources/), [Part 5:Pushing Data to the Server](http://lostechies.com/gabrielschenker/2013/12/17/angularjspart-5-pushing-data-to-the-server/), [Part 6: Templates](http://lostechies.com/gabrielschenker/2013/12/28/angularjspart-6-templates/), [Part 7: Get Ready to Test](http://lostechies.com/gabrielschenker/2013/12/30/angularjspart-7-getting-ready-to-test/), [Part 8: More Choice When Testing](http://lostechies.com/gabrielschenker/2013/12/30/angularjspart-8-more-choice-when-testing/), [Part 9: Values and Constants](http://lostechies.com/gabrielschenker/2014/01/14/angularjspart-9-values-and-constants/), [Part 10: Intermezzo](http://lostechies.com/gabrielschenker/2014/01/20/angluarjspart-10-intermezzo/), [Part 11: Promises](http://lostechies.com/gabrielschenker/2014/02/04/angularjspart-11-promises/), [Part 12: Multi-language Support](http://lostechies.com/gabrielschenker/2014/02/11/angularjspart-12-multi-language-support/), [Part 13: Services](http://lostechies.com/gabrielschenker/2014/02/26/angular-jspart-13-services/), [Part 14: End To End Tests](http://lostechies.com/gabrielschenker/2014/04/18/angular-jspart-14-end-to-end-tests/), [Part 15: End To End Tests & Mocking](http://lostechies.com/gabrielschenker/2014/04/21/angularjspart-15-end-to-end-tests-and-mocking/), [Part 16: Forms](http://lostechies.com/gabrielschenker/2014/05/13/angularjspart-16-forms/)
* Creating a Visualization App Using the Google Charts API and AngularJS: [Part 1](http://www.sitepoint.com/creating-visualization-app-using-google-charts-api-angularjs/), [Part 2](http://www.sitepoint.com/creating-visualization-app-using-google-charts-api-angularjs-part-2/), [Part 3](http://www.sitepoint.com/creating-visualization-app-using-google-charts-api-angularjs-part-3/), [Part 4](http://www.sitepoint.com/creating-visualization-app-using-google-charts-api-angularjs-part4/)
* AngularJs Bootstrap Components: [Part 1 : Building Popover Directive](http://subliminalsources.com/9/building-angularjs-bootstrap-components-popover-directive-part-1/), [Part 2 : Building Collapse(Accordion) Directive](http://subliminalsources.com/97/angularjs-bootstrap-components-part-2-building-collapse-accordion-directive/), [Part 3 : Building Tabs Directive](http://subliminalsources.com/175/angularjs-bootstrap-components-tutorials-part-3-building-tabs-directive/)
* Building an Angular and Express App: [Part 1](http://start.jcolemorrison.com/building-an-angular-and-express-app-part-1/) , [Part 2](http://start.jcolemorrison.com/building-an-angular-and-express-app-part-2/)
* Angular Directives: A Beginner's Guide [Part 1](http://blog.trifork.com/2014/04/17/angular-directives-a-beginners-guide-part-1)
* [Building a blog using Flask and AngularJS Part 1](http://blog.john.mayonvolcanosoftware.com/building-a-blog-using-flask-and-angularjs-part-1/), [Building a blog using Flask and AngularJS Part 2](http://blog.john.mayonvolcanosoftware.com/building-a-blog-using-flask-and-angularjs-part-2/)
* AngularJS: Looking Under the Hood: [Part 1](https://www.binpress.com/tutorial/angular-js-looking-under-the-hood/153), [Part 2](https://www.binpress.com/tutorial/angular-js-looking-under-the-hood/158)
* Translation and Localization with AngularJSTranslation and Localization with AngularJS [Part 1](http://www.thebhwgroup.com/blog/2015/01/translation-localization-angularjs/)[Part 2](http://www.thebhwgroup.com/blog/2015/01/translation-localization-angularjs-part-2/)
* AngularJS by Example [Part 1](http://www.revillweb.com/angularjs-by-example/1-introduction/), [Part 2](http://www.revillweb.com/angularjs-by-example/2-project-structure/)

## Sample Apps
* [A Shopping Cart Application Built with AngularJS] (http://www.codeproject.com/Articles/576246/A-Shopping-Cart-Application-Built-with-AngularJS)
* [Build a feed reader with the Google feed API and AngularJS] (http://cacodaemon.de/index.php?id=51)
* [Learning AngularJS by Example – The Customer Manager Application] (http://weblogs.asp.net/dwahlin/archive/2013/10/25/learning-angularjs-by-example-the-customer-manager-application.aspx)
* [Remote Desktop Client with AngularJS and Yeoman](http://blog.mgechev.com/2014/02/08/remote-desktop-vnc-client-with-angularjs-and-yeoman/)
* [Create a TV Show Tracker using AngularJS, Node.js and MongoDB](http://sahatyalkabov.com/create-a-tv-show-tracker-using-angularjs-nodejs-and-mongodb/)
* [Creating a CRUD App in Minutes with Angular’s $resource](http://www.sitepoint.com/creating-crud-app-minutes-angulars-resource/)
* [Building the 2048 game in AngularJS](http://www.ng-newsletter.com/posts/building-2048-in-angularjs.html)
* [Building a Chat App with node-webkit, Firebase, and AngularJS](http://www.sitepoint.com/building-chat-app-node-webkit-firebase-angularjs/)
* [Writing AngularJS Apps Using ES6](http://www.sitepoint.com/writing-angularjs-apps-using-es6/)
* [Angular Material Admin Dashboard](https://github.com/flatlogic/angular-material-dashboard)

## Scopes & Compile
* [AngularJS and scope.$apply] (http://jimhoskins.com/2012/12/17/angularjs-and-apply.html)
* [angularjs.org watch, on pub sub, and you.] (http://eburley.github.io/2013/01/31/angularjs-watch-pub-sub-best-practices.html)
* [Unbinding $watch() Listeners In AngularJS] (http://www.bennadel.com/blog/2480-Unbinding-watch-Listeners-In-AngularJS.htm)
* [Directive Link, $observe, And $watch Functions Execute Inside An AngularJS Context] (http://www.bennadel.com/blog/2449-Directive-Link-observe-And-watch-Functions-Execute-Inside-An-AngularJS-Context.htm)
* [Nested Scopes in AngularJS] (http://jimhoskins.com/2012/12/14/nested-scopes-in-angularjs.html)
* [AngularJS: 6 Common Pitfalls Using Scopes] (http://thenittygritty.co/angularjs-pitfalls-using-scopes)
* Scoping AngularJS Directives: [Part 1] (http://spectaclelabs.io/blog/2013/06/22/scoping-angularjs-directives-part-1/), [Part 2](http://spectaclelabs.io/blog/2013/06/23/scoping-angularjs-directives-part-2/)
* [$watch How the $apply Runs a $digest] (http://angular-tips.com/blog/2013/08/watch-how-the-apply-runs-a-digest/)
* [AngularJS: $watch, $digest and $apply] (http://www.benlesh.com/2013/08/angularjs-watch-digest-and-apply-oh-my.html)
* [Removing the Unneeded Watches] (http://angular-tips.com/blog/2013/08/removing-the-unneeded-watches/)
* [Angular - $compile: How it works, How to use it.] (http://www.benlesh.com/2013/08/angular-compile-how-it-works-how-to-use.html)
* [A Glimpse of Angular.js $scope via Example] (http://ruoyusun.com/2013/08/24/a-glimpse-of-angularjs-scope-via-example.html)
* [Share state between controllers in AngularJS] (https://variadic.me/posts/2013-10-15-share-state-between-controllers-in-angularjs.html)
* [Make Your Own AngularJS, Part 1: Scopes And Digest] (http://teropa.info/blog/2013/11/03/make-your-own-angular-part-1-scopes-and-digest.html)
* [Scope $watch() vs. $watchCollection() In AngularJS] (http://www.bennadel.com/blog/2566-Scope-watch-vs-watchCollection-In-AngularJS.htm)
* [A Tale of Frankenstein and Binding to Service Values in Angular.js] (http://stsc3000.github.io/blog/2013/10/26/a-tale-of-frankenstein-and-binding-to-service-values-in-angular-dot-js/)
* [AngularJS Scopes: An Introduction] (http://blog.carbonfive.com/2014/02/11/angularjs-scopes-an-introduction/)
* [Angle Brackets, Rifle Scopes] (http://blog.ponyfoo.com/2014/02/14/angle-brackets-rifle-scopes)
* [Mastering the Scope of the Directives in AngularJS](http://www.undefinednull.com/2014/02/11/mastering-the-scope-of-a-directive-in-angularjs/)
* [5 Guidelines For Avoiding Scope Soup in Angular] (http://www.technofattie.com/2014/03/21/five-guidelines-for-avoiding-scope-soup-in-angular.html)
* [Speeding up AngularJS's $digest loop] (https://coderwall.com/p/d_aisq)
* [Using Scope.$watch() To Watch Functions In AngularJS] (http://www.bennadel.com/blog/2658-using-scope-watch-to-watch-functions-in-angularjs.htm)
* [Looking At $compile() And MaxPriority In AngularJS] (http://www.bennadel.com/blog/2651-looking-at-compile-and-maxpriority-in-angularjs.htm)
* [Workflow Differences Between $scope.$watch() and Attributes.$observe() In AngularJS]  (http://www.bennadel.com/blog/2631-workflow-differences-between-scope-watch-and-attributes-observe-in-angularjs.htm)
* [Looking At How scope.$evalAsync() Affects Performance In AngularJS Directives] (http://www.bennadel.com/blog/2635-looking-at-how-scope-evalasync-affects-performance-in-angularjs-directives.htm)
* [$scope.$evalAsync() vs. $timeout() In AngularJS] (http://www.bennadel.com/blog/2605-scope-evalasync-vs-timeout-in-angularjs.htm)
* [Leverage Scope Creep! An in-depth tutorial on Angular.js Scope] (http://modernweb.com/2014/07/14/leverage-scope-creep-depth-tutorial-angular-js-scope/)
* [Rethinking AngularJS Controllers] (http://toddmotto.com/rethinking-angular-js-controllers/)
* [AngularJS: "Controller as" or "$scope"?] (http://codetunnel.com/angularjs-controller-as-or-scope/)
* [AngularJS’s Controller As and the vm Variable] (http://www.johnpapa.net/angularjss-controller-as-and-the-vm-variable/)
* [Delaying the $digest Cycle in AngularJS] (http://www.aaron-gray.com/delaying-the-digest-cycle-in-angularjs/)
* [AngularJS’ Internals In Depth](http://www.smashingmagazine.com/2015/01/22/angularjs-internals-in-depth/)
* [Superfast Angular: use ngModelOptions to limit $digest cycles](http://toddmotto.com/super-fast-angular-ng-model-options-limit-digest-cycles/)

## Dependency Injection
* [The "Magic" behind AngularJS Dependency Injection] (http://www.alexrothenberg.com/2013/02/11/the-magic-behind-angularjs-dependency-injection.html)
* [AngularJS: More on Dependency Injection] (http://dailyjs.com/2013/05/23/angularjs-injection/)
* [Angularjs Dependency Injection](http://diegobarahona.com/javascript/angularjs/2013/06/13/angularjs-dependency-injection/)
* [Configuring Dependency Injection in AngularJS] (http://joelhooks.com/blog/2013/08/18/configuring-dependency-injection-in-angularjs/)
* [Defining Instantiatable Classes In The AngularJS Dependency Injection Framework] (http://www.bennadel.com/blog/2527-Defining-Instantiatable-Classes-In-The-AngularJS-Dependency-Injection-Framework.htm)
* [Deconstructing AngularJS Injector] (http://neverfriday.com/2013/11/30/deconstructing-angularjs-injector/)
* [AngularJS Dependency Injection - Demystified](http://anandmanisankar.com/posts/angularjs-dependency-injection-demystified/)
* [Angular’s dependency injection annotation process](http://toddmotto.com/angular-js-dependency-injection-annotation-process/)

## Directives
* [AngularJS directives and the computer science of JavaScript] (http://www.adobe.com/devnet/html5/articles/angularjs-directives-and-the-computer-science-of-javascript.html)
* [AngularJS Directives - Domain-Specific Extensions to HTML] (http://henriquat.re/directives/introduction-to-directives/introductionToDirectives.html)
* [AngularJS Directives Tutorial] (http://www.befundoo.com/university/tutorials/angularjs-directives-tutorial/)
* [Commentable: A Polymorphic Nested Comments Directive for AngularJS] (http://panthersoftware.com/blog/2013/05/30/commentable-a-polymorphic-nested-comments-directive-for-angularjs/)
* [The ngForm directive of AngularJS] (http://blog.brunoscopelliti.com/the-ngform-directive-of-angularjs)
* [Run a directive after the DOM has finished rendering] (http://blog.brunoscopelliti.com/run-a-directive-after-the-dom-has-finished-rendering)
* [Use Cases of AngularJS Directives] (http://blog.brunoscopelliti.com/use-cases-of-angularjs-directives)
* [My Approach To Building AngularJS Directives That Bind To JavaScript Events] (http://www.bennadel.com/blog/2476-My-Approach-To-Building-AngularJS-Directives-That-Bind-To-JavaScript-Events.htm)
* [Delegating Nested Directive Behavior To Parent Directive In AngularJS] (http://www.bennadel.com/blog/2471-Delegating-Nested-Directive-Behavior-To-Parent-Directive-In-AngularJS.htm)
* [Exploring Directive Controllers, Compiling, Linking, And Priority In AngularJS] (http://www.bennadel.com/blog/2447-Exploring-Directive-Controllers-Compiling-Linking-And-Priority-In-AngularJS.htm)
* [Using Controllers In Directives In AngularJS] (http://www.bennadel.com/blog/2446-Using-Controllers-In-Directives-In-AngularJS.htm)
* [Angular.js Directives with JSON arguments] (http://www.grobmeier.de/angular-js-directives-with-json-arguments-08012013.html)
* [The Hitchhiker’s Guide to the Directive] (http://amitgharat.wordpress.com/2013/06/08/the-hitchhikers-guide-to-the-directive/)
* [Creating a Simple AngularJS Directive] (http://codingsmackdown.tv/blog/2012/12/14/creating-a-simple-angularjs-directive/)
* [Extending HTML With AngularJS Directives] (http://www.codeproject.com/Articles/607873/Extending-HTML-with-AngularJS-Directives)
* [Building Nested Recursive Directives in Angular] (http://sporto.github.io/blog/2013/06/24/nested-recursive-directives-in-angular/)
* [An all-in-one directive-controller with AngularJS] (http://icelab.com.au/articles/an-all-in-one-directive-controller-with-angularjs/)
* [Levelling Up With AngularJS: Building a Reusable Click to Edit Directive] (http://icelab.com.au/articles/levelling-up-with-angularjs-building-a-reusable-click-to-edit-directive/)
* [AngularJS Directives That Override Standard HTML Tags] (http://joelhooks.com/blog/2013/07/15/a-look-at-angularjs-internal-directives-that-override-standard-html-tags/)
* [AngularJS Directive for Mobile Sliders] (http://ngokevin.com/blog/angularslider/)
* [Using Namespaces For One-Off Directives In AngularJS] (http://www.bennadel.com/blog/2494-Using-Namespaces-For-One-Off-Directives-In-AngularJS.htm)
* [AngularJS and $compile] (http://www.phase2technology.com/blog/angularjs-and-compile/)
* [In-depth directives](http://www.ng-newsletter.com/posts/directives.html)
* [AngularJS: Referencing the parent scope in a directive] (http://www.grobmeier.de/angularjs-referencing-parent-scope-directive-23082013.html)
* [Tip: Directives With the Same Name] (http://angular-tips.com/blog/2013/08/tip-directives-with-the-same-name/)
* [Moving Data In An AngularJS Directive] (http://odetocode.com/blogs/scott/archive/2013/09/11/moving-data-in-an-angularjs-directive.aspx)
* [Building a Custom AngularJS Unique Value Directive] (http://weblogs.asp.net/dwahlin/archive/2013/09/24/building-a-custom-angularjs-unique-value-directive.aspx)
* [Creating an AngularJS Directive from one of your existing plugins/scripts] (http://toddmotto.com/creating-an-angularjs-directive-from-one-of-your-existing-plugins-scripts/)
* [Angular.js directives – Difference between controller and link] (http://jasonmore.net/angular-js-directives-difference-controller-link/)
* [AngularJS Directives Tutorial] (http://www.befundoo.com/university/tutorials/angularjs-directives-tutorial/)
* [AngularJS Directive Design Made Easy] (http://seanhess.github.io/2013/10/14/angularjs-directive-design.html)
* [Refactoring to AngularJS Directive] (http://suhairhassan.com/2013/10/21/refactoring-to-angularjs-directive.html)
* [Use jQuery Plugin With AngularJS the Easy (Lazy) Way] (http://iarouse.com/blog/2013/11/14/use-jquery-plugin-with-angularjs-the-easy-lazy-way/)
* [Defer DOM Tree Binding In AngularJS With Delayed Transclusion] (http://www.bennadel.com/blog/2557-Defer-DOM-Tree-Binding-In-AngularJS-With-Delayed-Transclusion.htm)
* Understanding AngularJS Directives: [Part 1:  Ng-repeat and Compile](http://liamkaufman.com/blog/2013/05/13/understanding-angularjs-directives-part1-ng-repeat-and-compile/), [Part 2: ngView](http://liamkaufman.com/blog/2013/11/11/understanding-angularjs-directives-part2-ng-view/)
* [Advanced Directives: Combining AngularJS with existing Components] (http://henriquat.re/directives/advanced-directives-combining-angular-with-existing-components-and-jquery/angularAndJquery.html)
* [Changes In Transclude() Function Availability In AngularJS 1.2] (http://www.bennadel.com/blog/2561-Changes-In-Transclude-Function-Availability-In-AngularJS-1-2.htm)
* [Leveraging Directives To Reduce $Watch'ers In Angular] (http://frontendandvodka.com/watchers-when-performance-is-key/)
* [Creating Semantic, Reusable Directives in AngularJS](http://jaysoo.ca/2014/01/20/semantic-angularjs-directives/)
* [Angle Brackets, Synergistic Directives] (http://blog.ponyfoo.com/2014/02/19/angle-brackets-synergistic-directives)
* [Transclusion in Angular] (http://engineering.nulogy.com/posts/transclusion-in-angular/)
* [Designing AngularJS Directives] (http://engineering.nulogy.com/posts/designing-angularjs-directives/)
* [How to integrate your UI Widgets with AngularJS] (http://blog.mobiscroll.com/how-to-integrate-your-ui-widgets-with-angularjs/)
* [Writing More Maintainable Angular.js Directives] (http://www.codelord.net/2014/03/30/writing-more-maintainable-angular-dot-js-directives/)
* [Creating Custom AngularJS Directives Part I - Fundamentals](http://weblogs.asp.net/dwahlin/creating-custom-angularjs-directives-part-i-the-fundamentals)
* [Creating Custom AngularJS Directives Part II - Isolate Scope](http://weblogs.asp.net/dwahlin/creating-custom-angularjs-directives-part-2-isolate-scope)
* [Looking At Attribute Interpolation Workflow Changes In AngularJS] (http://www.bennadel.com/blog/2650-looking-at-attribute-interpolation-workflow-changes-in-angularjs.htm)
* [Using Isolate Scope In Directives In AngularJS] (http://www.bennadel.com/blog/2646-using-isolate-scope-in-directives-in-angularjs.htm)
* [Shadowing Isolate Scope Behaviors In AngularJS] (http://www.bennadel.com/blog/2647-shadowing-isolate-scope-behaviors-in-angularjs.htm)
* [Custom Directives In AngularJS](http://blog.hfarazm.com/category/angular-js/)
* [Extending HTML with AngularJS's Directives](http://code.tutsplus.com/tutorials/extending-html-with-angularjss-directives--cms-21840)
* [Developing With AngularJS? Forget jQuery Exists.](http://tech.zumba.com/2014/08/02/angularjs-forget-jquery/)
* [A Guide To Transclusion In AngularJS](http://teropa.info/blog/2015/06/09/transclusion.html)

## Services/Providers
* [Angular service or factory?] (http://iffycan.blogspot.com/2013/05/angular-service-or-factory.html)
* [How to create (singleton) AngularJS services in 4 different ways] (http://blog.jdriven.com/2013/03/how-to-create-singleton-angularjs-services-in-4-different-ways/)
* [Moving AJAX calls to a custom service in Angular JS] (http://sravi-kiran.blogspot.com/2013/03/MovingAjaxCallsToACustomServiceInAngularJS.html)
* [Consuming Services] (http://angular-tips.com/blog/2013/08/consuming-services/)
* [Understanding Service Types] (http://angular-tips.com/blog/2013/08/understanding-service-types/)
* [Understanding angular $http interceptors] (http://djds4rce.wordpress.com/2013/08/13/understanding-angular-http-interceptors/)
* [Differences Between Providers In AngularJS] (http://blog.xebia.com/2013/09/01/differences-between-providers-in-angularjs/)
* [Angular's Modules: Factory, Service, Value, oh my!] (https://docs.google.com/document/d/1gkDp8HJU5Hdgse6d0Ol0_nsi9MQulVTbRCkEThW0RRY/edit#)
* [Angular Constants, Values, Factories, Services, Providers and Decorators, Oh My!] (http://www.mikeobrien.net/blog/angular-consts-values-services-factories-and-providers-oh-my/)
* [AngularJS Service / Factory Tutorial With Example] (http://viralpatel.net/blogs/angularjs-service-factory-tutorial/)
* [Service Providers in AngularJS and Logger Implementation] (http://www.webdeveasy.com/service-providers-in-angularjs-and-logger-implementation/)
* [Object-oriented AngularJS Services] (http://blog.revolunet.com/blog/2014/02/14/angularjs-services-inheritance/)
* [Service Providers in AngularJS and Logger Implementation] (http://www.webdeveasy.com/service-providers-in-angularjs-and-logger-implementation/)
* [AngularJS: Factory vs Service vs Provider] (http://tylermcginnis.com/angularjs-factory-vs-service-vs-provider/)
* [Building an AngularJS Modal Service](http://weblogs.asp.net/dwahlin/building-an-angularjs-modal-service)
* [Keeping Angular “service” collection data in sync with controllers] (http://www.justinobney.com/keeping-angular-service-list-data-in-sync-among-multiple-controllers/)

## Routing
* [How to defer route definition in an AngularJS web app] (http://blog.brunoscopelliti.com/how-to-defer-route-definition-in-an-angularjs-web-app)
* [AngularJS State Management with ui-router] (http://txt.fliglio.com/2013/05/angularjs-state-management-with-ui-router/)
* [Nested Views, Routing, And Deep Linking With AngularJS] (http://www.bennadel.com/blog/2441-Nested-Views-Routing-And-Deep-Linking-With-AngularJS.htm)
* [Angular UI router](http://angular-ui.github.io/ui-router/sample/#/)
* [The basics of using ui-router with AngularJS] (http://joelhooks.com/blog/2013/07/22/the-basics-of-using-ui-router-with-angularjs/)
* [AngularJS Routing Changes] (http://weblogs.asp.net/dwahlin/archive/2013/08/14/angularjs-routing-changes.aspx)
* [Cancelling Route Navigation in AngularJS Controllers] (http://weblogs.asp.net/dwahlin/archive/2013/11/07/cancelling-route-navigation-in-angularjs-controllers.aspx)
* [AngularJS Routing And Views Tutorial With Example](http://viralpatel.net/blogs/angularjs-routing-and-views-tutorial-with-example)
* [Single Page Apps with AngularJS Routing and Templating](http://scotch.io/tutorials/javascript/single-page-apps-with-angularjs-routing-and-templating)
* [AngularJS: Timing Multiple $resource Resolves in ngRoute and ui-router] (http://phillippuleo.com/articles/angularjs-timing-multiple-resource-resolves-ngroute-and-ui-router)
* [Advanced routing and resolves] (https://medium.com/opinionated-angularjs/a2fcbf874a1c)
* [AngularJS Routing Using UI-Router] (http://scotch.io/tutorials/javascript/angular-routing-using-ui-router)
* [Extending Dynamic View Loading for CRUD actions in AngularJS] (http://circuitbomb.com/anjularjs-extending-dynamic-view-loading-crud-actions/)
* [Using Resolve In AngularJS Routes] (http://odetocode.com/blogs/scott/archive/2014/05/20/using-resolve-in-angularjs-routes.aspx)

## Promises/Deferred
* [A better way to learn angularjs promises] (https://thinkster.io/a-better-way-to-learn-angularjs/promises)
* [Enhancing Angular Promises: Returning new promise of field or method called from original promise’s result] (http://www.blogeek.com.ar/2013/05/02/enhancing-angular-promises-returning-new-promise-of-field-or-method-called-from-original-promises-result/)
* [AngularJS promise, or dealing with asynchronous requests in AngularJS] (http://blog.brunoscopelliti.com/angularjs-promise-or-dealing-with-asynchronous-requests-in-angularjs)
* [Taking Advantage of Futures in AngularJS] (http://imownbey.github.io/skinny_controllers_for_yeezus.html)
* [Using Promises in AngularJS Views] (http://markdalgleish.com/2013/06/using-promises-in-angularjs-views/)
* [Using AngularJS Promises] (http://liamkaufman.com/blog/2013/09/09/using-angularjs-promises/)
* [Show route only after all promises are resolved] (http://blog.brunoscopelliti.com/show-route-only-after-all-promises-are-resolved)
* [The AngularJs Promise Anti-Pattern That Makes Me Cry] (http://terussell85.github.io/blog/2013/12/23/the-angularjs-promise-anti-pattern-that-makes-me-cry/)
* [Promises & Design Patterns in AngularJS](http://blog.xebia.com/2014/02/23/promises-and-design-patterns-in-angularjs/)
* [Canceling $http Requests in AngularJS] (http://odetocode.com/blogs/scott/archive/2014/04/24/canceling-http-requests-in-angularjs.aspx)
* [AngularJS Promises - The Definitive Guide](http://www.dwmkerr.com/promises-in-angularjs-the-definitive-guide/)
* [Promises in AngularJS, Explained as a Cartoon](http://andyshora.com/promises-angularjs-explained-as-cartoon.html)

## Forms
* [Form Validation the AngularJS Way] (http://blog.brunoscopelliti.com/form-validation-the-angularjs-way)
* [AngularJS Directive to test the strength of a password] (http://blog.brunoscopelliti.com/angularjs-directive-to-test-the-strength-of-a-password)
* [AngularJS Directive to check that passwords match] (http://blog.brunoscopelliti.com/angularjs-directive-to-check-that-passwords-match)
* [Mixing Static And Dynamic Data In An AngularJS Select Menu] (http://www.bennadel.com/blog/2452-Mixing-Static-And-Dynamic-Data-In-An-AngularJS-Select-Menu.htm)
* [Angular.js: ng-select and ng-options] (http://www.grobmeier.de/angular-js-ng-select-and-ng-options-21112012.html)
* [Angular.js: Autocomplete and enabling a form with $watch and blur] (http://www.grobmeier.de/angular-js-autocomplete-and-enabling-a-form-with-watch-and-blur-19112012.html)
* [Create AngularJS Directives to Remove Duplicate Code in Forms] (http://kazimanzurrashid.com/posts/create-angularjs-directives-to-remove-duplicate-codes-in-form)
* [Forced Repaints In Directive Can Cause Accidental Scrolling In AngularJS] (http://www.bennadel.com/blog/2468-Forced-Repaints-In-Directive-Can-Cause-Accidental-Scrolling-In-AngularJS.htm)
* [Using ngOptions in AngularJS] (http://odetocode.com/blogs/scott/archive/2013/06/19/using-ngoptions-in-angularjs.aspx)
* [Showing Validation Messages In Bulk While Validating Form Using Angular JS] (http://sravi-kiran.blogspot.com/2013/06/ShowingValidationMessagesInBulkWhileValidatingFormUsingAngularJS.html)
* [A directive to manage file upload in an AngularJS application] (http://blog.brunoscopelliti.com/a-directive-to-manage-file-upload-in-an-angularjs-application)
* [Radio Buttons With AngularJS] (http://odetocode.com/blogs/scott/archive/2013/06/25/radio-buttons-with-angularjs.aspx)
* [Reference the Current FormController in AngularJS] (http://shazwazza.com/post/Reference-the-current-form-controller-in-AngularJS)
* [Listening for Validation Changes in AngularJS] (http://shazwazza.com/post/Listening-for-validation-changes-in-AngularJS)
* [What A Select $watch() Teaches Me About ngModel And AngularJS] (http://www.bennadel.com/blog/2492-What-A-Select-watch-Teaches-Me-About-ngModel-And-AngularJS.htm)
* [On the Bleeding Edge: Advanced AngularJS Form Validation] (http://code.realcrowd.com/on-the-bleeding-edge-advanced-angularjs-form-validation/)
* [Twitter Bootstrap control-group directive for AngularJS] (http://aboutcode.net/2013/07/13/twitter-bootstrap-control-group-directive-for-angularjs.html)
* [Preventing Duplicate Requests in AngularJS] (http://blog.codebrag.com/post/57412530001/preventing-duplicated-requests-in-angularjs)
* [AngularJS Missing Directives: Native Form Resets] (http://blog.jasoncust.com/2013/08/angularjs-missing-directives-native.html)
* [AngularJS Missing Directives: Focus & Blur] (http://blog.jasoncust.com/2013/08/angularjs-missing-directives-focus-blur_14.html)
* [Angular JS: Validating Form Elements in a Repeat] (http://www.benlesh.com/2013/03/angular-js-validating-form-elements-in.html)
* [Angular JS: Custom Validation via Directives] (http://www.benlesh.com/2012/12/angular-js-custom-validation-via.html)
* [Angular JS: Form Validation] (http://www.benlesh.com/2012/11/angular-js-form-validation.html)
* [In depth form validation](http://www.ng-newsletter.com/posts/validations.html)
* [Ng-model and custom form validation] (http://jeremymarc.github.io/2013/08/20/ng-model-and-custom-form-validation/)
* [Angular JS Ajax dropdowns, date picker and saving data] (http://www.amitavroy.com/justread/content/articles/angular-js-ajax-dropdowns-date-picker-and-saving-data)
* [The concepts of AngularJS Forms] (http://mrbool.com/the-concepts-of-angularjs-forms/29117)
* [GitHub Like Signup Form With AngularJS and Bootstrap V3](http://mircozeiss.com/github-like-signup-form-with-angularjs-and-bootstrap-v3/)
* [Submitting AJAX Forms: The AngularJS Way](http://scotch.io/tutorials/javascript/submitting-ajax-forms-the-angularjs-way)
* [Create a Reusable AngularJS Input Form Component] (http://blog.revolunet.com/blog/2013/11/28/create-resusable-angularjs-input-component/)
* [Form Navigator With Instant Feedback in AngularJS] (http://www.codeorbits.com/blog/2013/11/26/form-navigator-with-real-time-feedback-in-angularjs/)
* [AngularJS Form Validation] (http://scotch.io/tutorials/javascript/angularjs-form-validation)
* [Processing Forms in AngularJS] (https://www.lullabot.com/blog/article/processing-forms-angularjs)
* [Object Equivalency and Select Options in AngularJS ("Why Isn't the Correct Option Selected?")] (http://www.thoughtdelimited.org/thoughts/post.cfm/object-equivalency-and-select-options-in-angularjs-why-isn-t-the-correct-option-selected)
* [Validation in angular.js ng-repeat](http://www.mikitamanko.com/blog/2014/02/11/validation-in-angular-js-ng-repeat/)
* [Handling Checkboxes and Radio Buttons in Angular Forms] (http://scotch.io/tutorials/javascript/handling-checkboxes-and-radio-buttons-in-angular-forms)
* [HTML Forms in AngularJS](http://www.sitepoint.com/html-forms-angularjs/)
* [Common Problems (And Solutions) When Using Select Elements With Angular.JS](http://gurustop.net/blog/2014/01/28/common-problems-and-solutions-when-using-select-elements-with-angular-js-ng-options-initial-selection/)
* [Using CSRF protection with Express and AngularJS](http://www.mircozeiss.com/using-csrf-with-express-and-angular/)
* ["Add more element" form with Angular](http://blog.chorip.am/articles/add-more-form-style-the-nice-way-with-angularjs/)
* [AngularJS Multi-Step Form Using UI Router](http://scotch.io/tutorials/javascript/angularjs-multi-step-form-using-ui-router)
* [Building Dynamic Angular Forms with ngRepeat and ngForm](http://scotch.io/tutorials/javascript/building-dynamic-angular-forms-with-ngrepeat-and-ngform)
* [**Taming Forms in AnguarJS 1.3] (http://www.yearofmoo.com/2014/09/taming-forms-in-angularjs-1-3.html)
* [**Asynchronous form errors and messages in AngularJS] (http://jaysoo.ca/2014/10/14/async-form-errors-and-messages-in-angularjs/)
* [**$touched is the new $dirty – AngularJS Migration Guide 1.2 to 1.3] (http://blog.lingohub.com/developers/2014/10/angularjs-migration-guide-1-2-to-1-3/)
* [**Exploring Angular 1.3 - One-Time Bindings] (http://blog.thoughtram.io/angularjs/2014/10/14/exploring-angular-1.3-one-time-bindings.html)
* [**Exploring Angular 1.3 - ng-model-options] (http://blog.thoughtram.io/angularjs/2014/10/19/exploring-angular-1.3-ng-model-options.html)
* [**Working with Validators and Messages in AngularJS] (http://odetocode.com/blogs/scott/archive/2014/10/16/working-with-validators-and-messages-in-angularjs.aspx)

## Authentication
* [Deal with users authentication in an AngularJS web app] (http://blog.brunoscopelliti.com/deal-with-users-authentication-in-an-angularjs-web-app)
* [Authentication in Single Page Applications with Angular.js](http://www.frederiknakstad.com/authentication-in-single-page-applications-with-angular-js/)
* [AngularJS -- Quick Role-Based Authentication] (http://arthur.gonigberg.com/2013/06/29/angularjs-role-based-auth/)
* [Authentication in Single Page Applications] (https://vickev.com/#!/article/authentication-in-single-page-applications-node-js-passportjs-angularjs)
* [Authentication with AngularJS] (https://medium.com/p/4e927af3a15f)
* [Cookies vs Tokens. Getting auth right with Angular.JS] (http://blog.auth0.com/2014/01/07/angularjs-authentication-with-cookies-vs-token/)
* [Techniques for authentication in AngularJS applications] (https://medium.com/opinionated-angularjs/7bbf0346acec)
* [Implementing Authentication in Angular Applications](http://www.sitepoint.com/implementing-authentication-angular-applications)
* [Thinkster: Simple AngularJS Authentication with JWT](https://thinkster.io/angularjs-jwt-auth/)


## Collections (& ngRepeat Stuff)
* [Working With Inherited Collections in AngularJS] (http://www.bennadel.com/blog/2485-Working-With-Inherited-Collections-In-AngularJS.htm)
* [Adding An ngRepeat List Delimiter In AngularJS] (http://www.bennadel.com/blog/2451-Adding-An-ngRepeat-List-Delimiter-In-AngularJS.htm)
* [Grouping Nested ngRepeat Lists In AngularJS] (http://www.bennadel.com/blog/2456-Grouping-Nested-ngRepeat-Lists-In-AngularJS.htm)
* [Using ngController With ngRepeat In AngularJS] (http://www.bennadel.com/blog/2450-Using-ngController-With-ngRepeat-In-AngularJS.htm)
* [Rendering DOM Elements With ngRepeat In AngularJS] (http://www.bennadel.com/blog/2443-Rendering-DOM-Elements-With-ngRepeat-In-AngularJS.htm)
* [Improving ng-repeat Performance with “track by”] (http://www.codelord.net/2014/04/15/improving-ng-repeat-performance-with-track-by/)


## Code Organization
* [Building Huuuuuge Apps with AngularJS] (http://briantford.com/blog/huuuuuge-angular-apps.html)
* [Code Organization in Large AngularJS and JavaScript Applications] (http://cliffmeyers.com/blog/2013/4/21/code-organization-angularjs-javascript)
* [Proposed Angular’s WebPage structure] (http://www.blogeek.com.ar/2013/05/18/proposed-angulars-project-structure/)
* [The right way of coding AngularJS: How to organize a regular WebApp. Basic Example] (http://www.blogeek.com.ar/2013/03/23/the-right-way-of-coding-angularjs-how-to-organize-a-regular-webapp/)
* [AngularJS Modules for Great Justice] (http://codingsmackdown.tv/blog/2013/04/19/angularjs-modules-for-great-justice/)
* [ngDefine: AngularJS & RequireJS] (https://github.com/Nikku/requirejs-angular-define)
* [Modular AngularJS App Design] (http://clintberry.com/2013/modular-angularjs-application-design/)
* [Using RequireJS with AngularJS DI] (http://solutionoptimist.com/2013/09/30/requirejs-angularjs-dependency-injection/)
* [Structuring AngularJS Code] (http://weblogs.asp.net/dwahlin/archive/2013/12/01/structuring-angularjs-code.aspx)
* [Loading AngularJS Components With RequireJS After Application Bootstrap] (http://www.bennadel.com/blog/2554-Loading-AngularJS-Components-With-RequireJS-After-Application-Bootstrap.htm)
* [Angular App Structuring Guidelines] (http://www.johnpapa.net/angular-app-structuring-guidelines/)
* [Side by Side Comparison of Expert Organization Approaches](http://www.dancancro.com/app-file-structure-comparison/)

## Testing
* [A Primer on Testing AngularJS Applications] (http://payworksmobile.com/blog/2015/03/05/a-primer-on-testing-angularjs-applications/)
* [Full-Spectrum Testing with AngularJS and Testacular] (http://www.yearofmoo.com/2013/01/full-spectrum-testing-with-angularjs-and-testacular.html)
* [Mocking Promises in Unit Tests] (http://codingsmackdown.tv/blog/2012/12/28/mocking-promises-in-unit-tests/)
* [How To Test An AngularJS Directive] (http://newtriks.com/2013/04/26/how-to-test-an-angularjs-directive/)
* [Unit Testing AngularJS Controllers Using Jasmine] (http://sravi-kiran.blogspot.com/2013/04/UnitTestingAngularJsControllerUsingJasmine.html)
* [Unit Testing AngularJS Controller Using QUnit and Sinon] (http://sravi-kiran.blogspot.com/2013/06/UnitTestingAngularJsControllerUsingQUnitAndSinon.html)
* [Testing AngularJS Directives: Handling External Templates] (http://www.portlandwebworks.com/blog/testing-angularjs-directives-handling-external-templates)
* [How To Unit Test An Angular App] (http://www.alexrothenberg.com/2013/08/06/how-to-unit-test-an-angular-app.html)
* [Unit Testing - Directives] (http://www.benlesh.com/2013/06/angular-js-unit-testing-directives.html)
* [Unit Testing - Services] (http://www.benlesh.com/2013/06/angular-js-unit-testing-services.html)
* [Unit Testing - Controllers] (http://www.benlesh.com/2013/05/angularjs-unit-testing-controllers.html)
* [Mocking Server Dependencies in JavaScript and AngularJS] (http://flippinawesome.org/2013/09/09/mocking-server-dependencies-in-javascript-and-angularjs/)
* [Advanced Testing and Debugging in AngularJS] (http://www.yearofmoo.com/2013/09/advanced-testing-and-debugging-in-angularjs.html)
* [Unit Testing Best Practices in AngularJS] (http://andyshora.com/unit-testing-best-practices-angularjs.html)
* [Decorating your tests in AngularJS] (http://blogs.mulesoft.org/angularjs-using-decorators-for-unit-testing/)
* [How to Unit Test Controllers In AngularJS Without Setting Your Hair On Fire] (http://nathanleclaire.com/blog/2013/12/13/how-to-unit-test-controllers-in-angularjs-without-setting-your-hair-on-fire/)
* [Testing AngularJS directive templates with Jasmine and Karma] (http://daginge.com/technology/2013/12/14/testing-angular-templates-with-jasmine-and-karma/)
* [Unit and End to End Testing in AngularJS] (http://www.sitepoint.com/unit-and-e2e-testing-in-angularjs/)
* [Testing AngularJS Apps with Protractor] (http://blog.envylabs.com/post/61403296076/testing-angularjs-apps-with-protractor)
* [Getting started unit-testing Angular] (http://www.ng-newsletter.com/advent2013/#!/day/19)
* [Mock Unit Testing a AngularJS Local Storage Service with Karma and Jasmine] (http://ngokevin.com/blog/angular-unit-testing/)
* [AngularJS End to End Testing With Protractor - Easy Set Up With Yeoman, Grunt, Bower] (http://www.codeorbits.com/blog/2014/01/26/angularjs-end-to-end-testing-with-protractor-easy-set-up-with-yeoman/)
* [Unit Testing an AngularJS Directive] (http://blog.revolunet.com/blog/2013/12/05/unit-testing-angularjs-directive/)
* [Protractor - Testing Angular and Non Angular Sites] (http://ng-learn.org/2014/02/Protractor_Testing_With_Angular_And_Non_Angular_Sites/)
* [Test Filters in AngularJS] (http://www.ecofic.com/about/blog/test-filters-in-angularjs)
* [Creating an Eclipse UI to run AngularJS e2e tests using Karma](http://blog.diniscruz.com/2014/02/creating-eclipse-ui-to-run-angularjs.html?)
* [AngularJS Unit Testing Series] (http://angular-tips.com/blog/2014/02/introduction-to-unit-test-toc/)
* [A Tip for Angular Unit Tests with Promises] (http://brianmcd.com/2014/03/27/a-tip-for-angular-unit-tests-with-promises.html)
* [Writing Tests and Stomping Bugs in AngularJS] (http://blog.safaribooksonline.com/2014/04/01/writing-tests-stomping-bugs-angularjs/)
* [Unit Testing Services in AngularJS for Fun and for Profit] (http://nathanleclaire.com/blog/2014/04/12/unit-testing-services-in-angularjs-for-fun-and-for-profit/)
* [Getting Started With Protractor And Page Objects For AngularJS E2E Testing] (http://gaslight.co/blog/getting-started-with-protractor-and-page-objects-for-angularjs-e2e-testing)
* [Continuous Integration for AngularJS Applications with Jenkins](http://www.cardinalsolutions.com/cardinal/blog/custom-application-development/2014/07/continuous_integrati.html)
* [Unit Testing w/ AngularJS] (http://moduscreate.com/unit-testing-w-angularjs/)
* [AngularJS Unit Testing - For Real, Though] (http://quickleft.com/blog/angularjs-unit-testing-for-real-though)
* [Testing AngularJS Apps Using Karma] (https://www.airpair.com/angularjs/posts/testing-angular-with-karma)
* [An Introduction To Unit Testing In AngularJS Applications] (http://www.smashingmagazine.com/2014/10/07/introduction-to-unit-testing-in-angularjs/)
* [AngularJS Testing Tips: Testing Directives](http://www.sitepoint.com/angular-testing-tips-testing-directives/)
* [Unit testing AngularJS applications](https://www.airpair.com/angularjs/posts/unit-testing-angularjs-applications)
* [Proper testing of Angular JS applications with ES6 modules](https://medium.com/@tomastrajan/proper-testing-of-angular-js-applications-with-es6-modules-8cf31113873f)
* [Angular Unit Testing Quick Start](http://angulartestingquickstart.com/)
* [An Introduction To Unit Testing In AngularJS Applications](http://www.smashingmagazine.com/2014/10/introduction-to-unit-testing-in-angularjs/)

## RESTful Stuff
* [Using RESTful Controllers In An AngularJS Resource] (http://www.bennadel.com/blog/2433-Using-RESTful-Controllers-In-An-AngularJS-Resource.htm)
* [Restangular: New AngularJS framework to handle Rest API Restful Resources properly and easily] (http://www.blogeek.com.ar/2013/04/09/restangular-new-angular-framework-to-handle-restful-resources-properly-and-easily/)
* [New features on Restangular: the ultimate Rest API client for Angular] (http://www.blogeek.com.ar/2013/04/26/new-features-on-restangular-the-ultimate-rest-api-client-for-angularjs/)
* [Using an AngularJS Factory to Interact with a RESTful Service] (http://weblogs.asp.net/dwahlin/archive/2013/08/16/using-an-angularjs-factory-to-interact-with-a-restful-service.aspx)
* [Authentication to a RESTful web service in an AngularJS web app] (http://blog.brunoscopelliti.com/authentication-to-a-restful-web-service-in-an-angularjs-web-app)
* [XHR Interceptor in an AngularJS web app] (http://blog.brunoscopelliti.com/xhr-interceptor-in-an-angularjs-web-app)

## Localization
* [Localizing Your AngularJS Apps] (http://codingsmackdown.tv/blog/2013/04/23/localizing-your-angularjs-apps-update/)
* [Internazionalization (i18n) with AngularJS] (http://blog.brunoscopelliti.com/internazionalization-i18n-with-angularjs)
* [AngularJS And i18n] (https://coderwall.com/p/uyrtpq)
* [Easy global i18n angularJS language translations for your Angular app] (http://www.ng-newsletter.com/posts/angular-translate.html)
* [INTERNATIONALIZATION WITH ANGULARJS](http://blog.trifork.com/2014/04/10/internationalization-with-angularjs/)

## UI Stuff
* [Angular UI suite (including some subprojects)](http://angular-ui.github.io/)
* [Animation in AngularJS] (http://www.yearofmoo.com/2013/04/animation-in-angularjs.html)
* [Enhanced Animation in AngularJS] (http://www.yearofmoo.com/2013/05/enhanced-animations-in-angularjs.html)
* [A Reusable AngularJS Popup Dialog Service] (http://www.befundoo.com/blog/angularjs-popup-dialog/)
* [Creating A Custom Show / Hide Directive In AngularJS] (http://www.bennadel.com/blog/2440-Creating-A-Custom-Show-Hide-Directive-In-AngularJS.htm)
* [Bootstrap Tabs with Angular.js] (http://www.grobmeier.de/bootstrap-tabs-with-angular-js-25112012.html)
* [Using Response Interceptors to Show and Hide a Loading Widget] (http://codingsmackdown.tv/blog/2013/01/02/using-response-interceptors-to-show-and-hide-a-loading-widget/)
* [Building a Typeahead Directive with AngularJS] (http://hueypetersen.com/posts/2013/06/24/typeahead-with-angular/)
* [AngularJS Modal Service] (http://fundoo-solutions.github.io/angularjs-modal-service/)
* [Cross-Fading Images With AngularJS] (http://www.bennadel.com/blog/2497-Cross-Fading-Images-With-AngularJS.htm)
* [AngularJS and SVG] (http://dailyjs.com/2013/06/07/angular-svg/)
* [AngularJS: Scroll Animations] (http://jjperezaguinaga.wordpress.com/2013/07/16/angularjs-scroll-animations/)
* [Animating with AngularJS] (http://flippinawesome.org/2013/08/05/animating-with-angularjs/)
* [Drag and Drop File Upload with AngularJS] (http://buildinternet.com/2013/08/drag-and-drop-file-upload-with-angularjs/)
* [Remastered Animation in AngularJS 1.2] (http://www.yearofmoo.com/2013/08/remastered-animation-in-angularjs-1-2.html)
* [Angular JS - Scrolling To An Element By Id] (http://www.benlesh.com/2013/02/angular-js-scrolling-to-element-by-id.html)
* [Building an AngularJS Dialog Service] (http://weblogs.asp.net/dwahlin/archive/2013/08/19/building-an-angularjs-dialog-service.aspx)
* [Preparing for Animations in Angular 1.2.0] (http://www.johnpapa.net/preparing-for-animations-in-angular-1-2-0/)
* [Replacing jQuery.slideDown() with ngAnimate in AngularJS 1.2.0] (https://www.exratione.com/2013/09/replacing-jqueryslidedown-with-nganimate-in-angularjs-120/)
* [AngularJS: Blurred image directive] (http://veamospues.wordpress.com/2013/10/13/angularjs-blurred-image-directive/)
* [Create a “load more” widget using AngularJS, Ajax and Bootstrap 3] (http://julienrenaux.fr/2013/10/27/create-a-load-more-widget-using-angularjs-ajax-and-bootstrap-3/)
* [ngInfiniteScroll] (http://binarymuse.github.io/ngInfiniteScroll/index.html)
* [jQuery UI Datepicker with AngularJS] (http://www.abequar.net/jquery-ui-datepicker-with-angularjs/)
* [TimeSelector/TimePicker Directive] (http://www.whatibroke.com/?p=899)
* [Photo Gallery with AngularJS and CSS3] (http://www.script-tutorials.com/photo-gallery-with-angularjs-and-css3/)
* [A Scalable Approach to Page Transitions in AngularJS] (http://phillippuleo.com/articles/scalable-approach-page-transitions-angularjs)
* [Staggering Animations in AngularJS] (http://www.yearofmoo.com/2013/12/staggering-animations-in-angularjs.html)
* [Build a Sweet Photo Slider with AngularJS Animate](http://onehungrymind.com/build-sweet-photo-slider-angularjs-animate/)
* [Build a Sweet AngularJS Photo Slider Pt 2 with ngTouch] (http://onehungrymind.com/build-sweet-angularjs-photo-slider-pt-2-ngtouch/)
* [Creating a Slide Show Plugin With AngularJS](http://www.sitepoint.com/creating-slide-show-plugin-angularjs/)
* [Wallop Slider in AngularJS](http://andyshora.com/wallop-slider-angularjs-css.html)
* [Easy Animations For AngularJS With Animate.css] (http://odetocode.com/blogs/scott/archive/2014/02/25/easy-animations-for-angularjs-with-animate-css.aspx)
* [Conditionally Apply a CSS Class with AngularJS] (http://www.ecofic.com/about/blog/conditionally-apply-a-css-class-with-angularjs)
* [Animating AngularJS Apps: ngView] (http://scotch.io/tutorials/javascript/animating-angularjs-apps-ngview)
* [Creating Asynchronous Alerts, Prompts, And Confirms In AngularJS] (http://www.bennadel.com/blog/2632-creating-asynchronous-alerts-prompts-and-confirms-in-angularjs.htm)
* [Build an animated AngularJS website] (http://www.creativebloq.com/javascript/build-animated-angularjs-website-61411891)
* [https://medium.com/@mike360/animating-ng-view-on-route-change-in-angularjs-9490811d0470] (Animating ng-view on route change in AngularJS)
* [Advanced UI, Plugins and Components in AngularJS] (http://slides.yearofmoo.com/fitc-spotlight-angularjs/index.html)
* [Adding CSS Animations to AngularJS Applications](www.sitepoint.com/adding-css-animations-angularjs-applications)
* [JavaScript Animations in AngularJS Applications] (http://www.sitepoint.com/javascript-animations-angularjs-applications/)
* [Getting Started with Mobile Angular UI] (http://www.sitepoint.com/getting-started-mobile-angular-ui/)
* [Animate Your Angular Application](http://www.planningforaliens.com/angular/animate-your-angular-application/)
* [Using AngularJS for Data Visualisations](http://css-tricks.com/using-angularjs-for-data-visualisations/)
* [Thinkster: Creating Animations in Angular with ngAnimate](https://thinkster.io/angular-animations-tutorial/)


## Integration With Other Languages/Frameworks
* [AngularJS and TypeScript] (http://notebookheavy.com/2013/05/22/angularjs-and-typescript/)
* [Using AngularJS and D3 to Create a WordCloud Directive] (http://spiiice.net/using-angularjs-and-d3-to-create-a-wordcloud-directive/)
* [Using jQuery Event Delegation In AngularJS] (http://www.bennadel.com/blog/2448-Using-jQuery-Event-Delegation-In-AngularJS.htm)
* [Hooking up ASP.NET SignalR with Angular JS](http://sravi-kiran.blogspot.in/2013/05/HookingUpAspNetSignalRWithAngularJS.html)
* [Facebook Authentication in Your AngularJS App] (http://blog.brunoscopelliti.com/facebook-authentication-in-your-angularjs-web-app)
* [Automating AngularJS with Yeoman, Grunt & Bower] (http://newtriks.com/2013/06/11/automating-angularjs-with-yeoman-grunt-and-bower/)
* [Writing Reusable AngularJS Components with Bower] (http://briantford.com/blog/angular-bower.html)
* [Making Google Maps Components with AngularJS] (http://wbyoko.co/angularjs/angularjs-google-maps-components.html)
* [Sync Multiple AngularJS Apps Without Server via PouchDB] (http://mircozeiss.com/sync-multiple-angularjs-apps-without-server-via-pouchdb/)
* [Building Offline Applications With AngularJS and PouchDB] (http://mircozeiss.com/building-offline-applications-with-angularjs-and-pouchdb/)
* [How to integrate AngularJS with Rails 4] (https://shellycloud.com/blog/2013/10/how-to-integrate-angularjs-with-rails-4)
* [Using Breeze JS with Angular to consume Web API OData] (http://sravi-kiran.blogspot.com/2013/11/UsingBreezeJsToConsumeAspNetWebApiODataInAnAngularJsApplication.html)
* [A better way of using SignalR with Angular JS] (http://sravi-kiran.blogspot.com/2013/09/ABetterWayOfUsingAspNetSignalRWithAngularJs.html)
* [Using AngularJS with Django](http://glynjackson.org/weblog/entry/django-angular.html)
* [Using AngularJS/Bootstrap as frontend and CakePHP as REST API producer](https://github.com/hantsy/angularjs-cakephp-sample/wiki)
* [Creating Charting Directives Using AngularJS and D3.js](http://www.sitepoint.com/creating-charting-directives-using-angularjs-d3-js/)
* [Laravel 4 & AngularJS E2E secured SPA](http://blog.neoxia.com/laravel4-and-angularjs/)
* [Tips for using AngularJS in ASP.Net MVC] (http://www.justinobney.com/tips-for-using-angularjs-in-asp-net-mvc/)
* [Form validation with AngularJS and Rails](http://blog.cesarandreu.com/posts/form_validation_with_angularjs_and_rails)
* [How can React and Flux help us create better Angular applications?](https://medium.com/@gilbox/how-can-react-and-flux-help-us-create-better-stronger-faster-angular-applications-639247898fb)
* [Achieving Reasonable and Scalable Routing in AngularJS with Flux](https://medium.com/@gilbox/achieving-reasonable-and-scalable-routing-in-angularjs-with-flux-2655e06cd5ee)

## Hosted Backends
* [Parse.com boilerplate for building large, complex AngularJS apps](http://brandid.github.io/parse-angular-demo/#/features)
* [Realtime database for your Angular app with Firebase] (https://github.com/firebase/angularFire)
* [CRUD backend for Angular with Backlift] (https://blog.backlift.com/entry/angular-tut1)
* [Building Offline Applications With AngularJS and PouchDB] (http://mircozeiss.com/building-offline-applications-with-angularjs-and-pouchdb/)
* [CRUD backend for Angular with DreamFactory] (http://www.dreamfactory.com/angularjs-example)
* [Three-Way Data Binding with Firebase and Angular] (https://www.firebase.com/blog/2013-10-04-firebase-angular-data-binding.html)

## Mobile
* [Quick Start Guide to PhoneGap+AngularJS] (http://devgirl.org/2013/06/10/quick-start-guide-phonegap-and-angularjs/)
* [Building PhoneGap Apps with AngularJS] (http://briantford.com/blog/angular-phonegap.html)
* [PhoneGap And AngularJS: In App Browser] (http://tech.pro/tutorial/1357/phonegap-and-angularjs-in-app-browser)
* [PhoneGap And AngularJS: Notification Service] (http://tech.pro/tutorial/1349/phonegap-and-angularjs-notification-service)
* [Developing a mobile app with Phonegap, AngularJS and ExpressJS Part I] (http://abou-kone.com/2013/07/17/developing-a-mobile-app-with-phonegap-angularjs-and-expressjs-part-i/)
* [Sample Mobile Application with AngularJS] (http://coenraets.org/blog/2013/11/sample-mobile-application-with-angularjs/)
* [The Definitive Guide to Angular on Mobile] (http://www.ng-newsletter.com.s3-website-us-east-1.amazonaws.com/posts/angular-on-mobile.html)
* [Ionic Framework with AngularJS app development](http://ionicframework.com/)

## Popular Third-Party Modules
* [Bindonce - watchless AngularJS](https://github.com/Pasvaz/bindonce)
* [UI Bootstrap](http://angular-ui.github.io/bootstrap/)
* [Angularstrap](http://mgcrea.github.io/angular-strap/)
* [UI Router](https://github.com/angular-ui/ui-router)
* [Angular Material](https://material.angularjs.org/#/)

## Text editor bundles/IDE Stuff
* [Brackets (AngularJS Extension Available)](http://brackets.io/)
* [Sublime text 2 package](https://github.com/angular-ui/AngularJS-sublime-package)
* [VIM UltiSnip & Snipmate Snippets for AngularJS](https://github.com/matthewsimo/angular-vim-snippets)
* [Running JavaScript tests with Karma in WebStorm 7] (http://blog.jetbrains.com/webstorm/2013/10/running-javascript-tests-with-karma-in-webstorm-7/)
* [Visual Studio](http://www.microsoft.com/visualstudio)
* [Atom - AngularJS Helper](https://atom.io/packages/angularjs-helper)
* [Atom - AngularJS Snippets](https://atom.io/packages/angularjs-snippets)

## Development Tools
* [AngularJS Batarang Chrome Extension](https://github.com/angular/angularjs-batarang)
* [Scaffolding JSON or restful API to JavaScript and HTML using AngularJS and JQuery](http://spascaffold.azurewebsites.net/AngularJSScaffold)
* [ng-inspector for AngularJS](http://ng-inspector.org/)
